﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
    
public partial class ControlTree : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // this.Visible = false;
        // Начало сканирования всех нелитеральных элементов управления
        DisplayControl(Page.Controls, 0, false);

        // Горизонтальная линия по окончании вывода
        Response.Write("<hr />");
    }

    protected void Button4_Click(object sender, EventArgs e)
    {
        // Начало сканирования всех литеральных элементов управления
        DisplayControl(Page.Controls, 0, true);

        // Горизонтальная линия по окончании вывода
        Response.Write("<hr />");
    }

    private void DisplayControl(ControlCollection controls, int depth, bool literalFlag)
    {
        foreach (Control control in controls)
        {
            // Выявлять литеральные (статические) элементы управления
            bool literalControl = control is LiteralControl;

            // Отобразить элемент управления
            if (literalControl == literalFlag)
            {
                // Использовать параметр depth для определения
                // отступов в выводе дерева элементов управления
                Response.Write(new String('-', depth * 4) + "-->");

                String literalText = "";
                if (literalControl)
                    literalText = "text" + ((LiteralControl)control).Text;

                Response.Write(control.GetType().ToString() + " - <b>"
                    + control.ID + literalText + "</b><br />");
            }

            // Проверять дочерние элементы управления рекурсивно
            if (control.Controls != null)
            {
                DisplayControl(control.Controls, depth + 1, literalFlag);
            }
        }
    }
}
