﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class DynamicButton : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // Создать новый объект кнопки
        Button newButton = new Button();

        // Присвоить значения свойств
        newButton.ID = "newButton";
        newButton.Text = "* Dynamic Button *";

        // Добавить кнопку в коллекцию PlaceHolder1
        PlaceHolder1.Controls.Add(newButton);

        // Подключение обработчика события Button.Click
        // динамически созданного элемента управления
        newButton.Click += new EventHandler(newButton_Click);
    }

    void newButton_Click(object sender, EventArgs e)
    {
        Label1.Text = "Этот текст прислал обработчик" + 
                      " динамически созданной кнопки";
    }

    protected void Button3_Click(object sender, EventArgs e)
    {
        // Поиск кнопки вне зависимости от иерархического
        // уровня, в котором она расположена
        Button foundButton = (Button)Page.FindControl("newButton");

        // Удаление кнопки с проверкой условия, чтобы
        // не пытались удалить уже удаленный объект
        if (foundButton != null)
        {
            // Удаляем из коллекции родительского элемента управления
            foundButton.Parent.Controls.Remove(foundButton);
        }
    }
}
